"""
Bloglines Blogroll Extractor
Author: Nick Codignotto
Date: October 19, 2004
URL: http://www.primordia.com/blog
Notes: Some code taken from ActiveState forums
        http://aspn.activestate.com/ASPN/Cookbook/Python/Recipe/267197
"""

import sys
import getopt
import httplib
import xml.dom.minidom
import urllib2
import re
import base64
from urlparse import urlparse

username = 'YOUR USERNAME USUALLY E-MAIL'
password = 'YOUR PASSWORD'
podcastFolder = "YOUR BLOGROLL FOLDER THAT HAS PODCASTS IF NO FOLDER THEN USE Subscriptions"

# I wanted to touch a particular web page (in order to open/
# close a database connection inside of Zope) so I came
# up with this module which uses urllib2 to make the
# web connection
#
# I was not sure what a 'realm' was, so first I made the
# HTTPRealmFinder to find out what the realm is.
# The HTTPinger calls my required page and acts according
# to the http return code.

class HTTPinger:
    def ping(self, url, webuser, webpass):
        scheme, domain, path, x1, x2, x3 = urlparse(url)
        
        finder = HTTPRealmFinder(url)
        realm = finder.get()
        
        handler = urllib2.HTTPBasicAuthHandler()
        handler.add_password(realm, domain, webuser, webpass)
        
        opener = urllib2.build_opener(handler)
        urllib2.install_opener(opener)
        
        try:
            return urllib2.urlopen(url)
        except urllib2.HTTPError, e:
            if e.code == 401:
                print 'not authorized'
            elif e.code == 404:
                print 'not found'
            elif e.code == 503:
                print 'service unavailable'
            else:
                print 'unknown error: '
        else:
            print 'success'

        return 0;                    


class HTTPRealmFinderHandler(urllib2.HTTPBasicAuthHandler):
    def http_error_401(self, req, fp, code, msg, headers):
        realm_string = headers['www-authenticate']
        
        q1 = realm_string.find('"')
        q2 = realm_string.find('"', q1+1)
        realm = realm_string[q1+1:q2]
        
        self.realm = realm

class HTTPRealmFinder:
    def __init__(self, url):
        self.url = url
        scheme, domain, path, x1, x2, x3 = urlparse(url)
        
        handler = HTTPRealmFinderHandler()
        handler.add_password(None, domain, 'foo', 'bar')
        self.handler = handler
        
        opener = urllib2.build_opener(handler)
        urllib2.install_opener(opener)

    def ping(self, url):
        try:
            urllib2.urlopen(url)
        except urllib2.HTTPError, e:
            pass

    def get(self):
        self.ping(self.url)
        try:
            realm = self.handler.realm
        except AttributeError:
            realm = None
        
        return realm

    def prt(self):
        print self.get()
    
def getText(nodelist):
    rc = ""
    for node in nodelist:
        if node.nodeType == node.TEXT_NODE:
            rc = rc + node.data
    return rc

class Usage(Exception):
    def __init__(self, msg):
        self.msg = msg

class ExtractSubsApi:
    def __init__(self):
        pinger = HTTPinger()
        u = pinger.ping('http://rpc.bloglines.com/listsubs', username, password)
        data = u.read()
        
        dom = xml.dom.minidom.parseString(data)
        outlines = dom.getElementsByTagName("outline")
        for outline in outlines:
            title = outline.getAttribute("title")
            if title == podcastFolder:
                podcasts = outline.getElementsByTagName("outline")
                for podcast in podcasts:
                    xmlurl = podcast.getAttribute("xmlUrl")
                    if xmlurl != "":
                        print xmlurl;

def main(argv=None):
    if argv is None:
        argv = sys.argv
    try:
        try:
            opts, args = getopt.getopt(argv[1:], "h", ["help"])
        except getopt.error, msg:
             raise Usage(msg)

        ExtractSubsApi()
        
    except Usage, err:
        print >>sys.stderr, err.msg
        print >>sys.stderr, "for help use --help"
        return 2

if __name__ == "__main__":
    sys.exit(main())
